Unit BK04R3_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, BK04R4_p;

procedure BK04R3(var GAMMCF :Real; A :Real; X :Real; var GLN :Real); 

implementation

procedure BK04R3(var GAMMCF :Real; A :Real; X :Real; var GLN :Real);
var
N,ITMAX :Integer;
GOLD,A0,A1,B0,B1,FAC,AN,ANA,ANF,G,EPS :Real;
label
_11,_1;
begin
ITMAX := 100;
EPS := 3.E-7;
GLN := BK04R4(A);
GOLD := 0.0;
A0 := 1.0;
A1 := X;
B0 := 0.0;
B1 := 1.0;
FAC := 1.0;
for N:=1 to ITMAX do
 begin
  AN := (N);
  ANA := AN-A;
  A0 := (A1+A0*ANA)*FAC;
  B0 := (B1+B0*ANA)*FAC;
  ANF := AN*FAC;
  A1 := X*A0+ANF*A1;
  B1 := X*B0+ANF*B1;
  if ( A1 = 0.0 ) 
   then goto _11;
  FAC := 1.0/A1;
  G := B1*FAC;
  if ( Abs((G-GOLD)/G) < EPS )
   then goto _1;
  GOLD := G;
_11:
 end;
{       US ' t lrg, I t smll' }
_1:
GAMMCF := Exp(-X+A*Ln(X)-GLN)*G;
end;

end.
